﻿@model FunXgame.Models.Producto

@{
    ViewBag.Title = "CrearProducto";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">

    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}

    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Productos/ListarProducto">Listar Productos</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link active" style="color:white; background-color:black" href="#">Agregar Producto</a>
                    </li>
                </ul>
            </div>
            <div class="card-body text-left">

                @using (Html.BeginForm("CrearProducto", "Productos", FormMethod.Post, new { role = "form", id = "productoCreaForm", @class = "" }))
                {
                    @Html.AntiForgeryToken()

                <div class="form-horizontal">

                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Código:</label>
                            @Html.EditorFor(model => model.Codigo_producto, new { htmlAttributes = new { @class = "form-control", id = "Codigo_producto" } })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Estado:</label>
                            @Html.DropDownList("Id_estado", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "Id_estado" })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Marca:</label>
                            @Html.DropDownList("Id_marca", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "Id_marca" })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class=" col-md-10">
                            <label>Categoría:</label>
                            <select id="select_categoria" class="form-control" name="Id_categoria">
                                <option value="">Seleccione...</option>
                            </select>
                        </div>
                    </div>


                    

                    <div class="form-group">
                        <div class="col-md-10">
                            <img id=img src="~/Content/Assets/Imagenes/noImage.jpg" style="width:280px" />
                        </div>
                    </div>

                    <div class="form-group">
                        <label>Seleccione imagen:</label>
                        <div class="col-md-10">
                            @Html.DropDownList("Id_imagen", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "img_select" })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Nombre:</label>
                            @Html.EditorFor(model => model.Nombre_producto, new { htmlAttributes = new { @class = "form-control", id = "Nombre_producto" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Precio:</label>
                            @Html.EditorFor(model => model.Precio_producto, new { htmlAttributes = new { @class = "form-control soloNumeros", id = "Precio_producto" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Stock:</label>
                            @Html.EditorFor(model => model.Stock_producto, new { htmlAttributes = new { @class = "form-control soloNumeros", id = "Stock_producto" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Descripción:</label>
                            @Html.EditorFor(model => model.Descripcion_producto, new { htmlAttributes = new { @class = "form-control", id = "Descripcion_producto" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-offset-2 col-md-10">
                            <input id="btnGuardar" type="submit" value="Agregar Producto" class="btn btn-dark" />
                        </div>
                    </div>
                </div>
                }

            </div>
        </div>
    </div>
</div>



@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    <script src="~/Scripts/Validaciones/valida_producto.js"></script>

    <script>

        $(document).ready(function () {

            $('#Codigo_producto').blur(function () {
                validaCodigoNombreExiste('#Codigo_producto');
            });
            capturaIdMarca();
            capturaIdMarcaCategoria();
            $('#Nombre_producto').blur(function () {
                validaCodigoNombreExiste('#Nombre_producto');
            });

            enviaValidaProducto('Nuevo producto creado','','#productoCreaForm')
            limpiar();
        })



        $('#img_select').change(function () {
            $.ajax({
                type: 'POST',
                url: '@Url.Action("CargaImgPreview")',
                data: '{id:' + JSON.stringify($('#img_select').val()) + '}',
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result != "") {
                        $('#img').attr('src', result);
                        preview.style.display = "block";
                    }
                }
            });
        });

        function limpiar() {
            $('#Codigo_producto').val('');
            $('#Nombre_producto').val('');
            $('#Descripcion_producto').val('');
            $('#img_select').val('');
            $('#Precio_producto').val('');
            $('#Stock_producto').val('');
            $('#Id_marca').val('');
            $('#Id_estado').val('');

        }

        function validaCodigoNombreExiste(selector) {

            var valores = { Codigo_producto: $('#Codigo_producto').val().trim(), Nombre_producto: $('#Nombre_producto').val() };
            var resultado = JSON.stringify(valores);

            if ($(selector).val().trim() != '') {
                    $.ajax({
                        type: 'POST',
                        url: '@Url.Action("ExisteCodigoNombreProducto")',
                        data: resultado,
                        dataType: 'json',
                        contentType: 'application/json; charset=utf-8',
                        success: function (result) {
                            if (result == "codigoExiste") {
                                $('#Codigo_producto').val('');
                                swal("Ya existe un producto con ese código", "", "warning");
                            }

                            if (result == "nombreExiste") {
                                $('#Nombre_producto').val('');
                                swal("Ya existe un producto con ese nombre", "", "warning");
                            }
                        }
                    });
            }
        }

         function capturaIdMarca() {
            $('#Id_marca').change(function () {
                let idMarca = $('#Id_marca').val();

                $.ajax({
                type: 'POST',
                url: '@Url.Action("CapturaEstadoMarca")',
                data: '{id:' + JSON.stringify(idMarca) + '}',
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                    success: function (result) {
                    //AQUI MENSAJE MARCA DESACTIVADA
                    if (result == "marcaDesactivada") {
                        swal("La marca seleccionada no se encuetra activada",'Puede reactivarla en el panel de edición de marcas.', "warning");
                    }
                    if (result == "") {

                    }
                }
                });

                $.ajax({
                type: 'POST',
                url: '@Url.Action("GetCategorias")',
                data: '{id:' + JSON.stringify(idMarca) + '}',
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result != "") {

                            $('#select_categoria').html('');
                            var options = '';
                            options += '<option value="">Seleccione...</option>';

                            for (var i = 0; i < result.length; i++) {


                                options += '<option value="' + result[i].categoria + '">' + result[i].nombre + '</option>';
                            }
                            $('#select_categoria').append(options);
                    }
                    if (result == "") {
                        $('#select_categoria').html('');
                        $('#select_categoria').append('<option value="">Seleccione...</option>');
                    }
                }

                });

           });
        }

        function capturaIdMarcaCategoria() {
            $('#select_categoria').change(function () {

                var valores = { idMarca: $('#Id_marca').val(), idCategoria: $('#select_categoria').val() };
                var data = JSON.stringify(valores);
                $.ajax({
                type: 'POST',
                url: '@Url.Action("CapturaEstadoCategoria")',
                data: data,
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result == "categoriaDesactivada") {
                        //Mensaje categoria desactivada
                        swal("La categoria seleccionada no se encuetra activada", 'Puede reactivarla en el panel de edición de categorías.', "warning");
                    }
                }

                });

           });
        }

    </script>
}
